Index: library/doc/html/classbdm_1_1SettingResolver.html
===================================================================
--- library/doc/html/classbdm_1_1SettingResolver.html (revision 614)
+++ library/doc/html/classbdm_1_1SettingResolver.html (revision 616)
@@ -74,34 +74,4 @@
 <p>This class serves to expand links used within configuration files.  
 <a href="#_details">More...</a></p>
-
-<p><code>#include &lt;<a class="el" href="user__info_8h_source.html">user_info.h</a>&gt;</code></p>
-
-<p><a href="classbdm_1_1SettingResolver-members.html">List of all members.</a></p>
-<table border="0" cellpadding="0" cellspacing="0">
-<tr><td colspan="2"><h2>Public Member Functions</h2></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae2299746b95bf8af54a867aaf52fc8da"></a><!-- doxytag: member="bdm::SettingResolver::SettingResolver" ref="ae2299746b95bf8af54a867aaf52fc8da" args="(const Setting &amp;potential_link)" -->
-&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1SettingResolver.html#ae2299746b95bf8af54a867aaf52fc8da">SettingResolver</a> (const Setting &amp;potential_link)</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">If potential_link contains a link to some other setting, it is resolved here. Anyway, the Setting reference <a class="el" href="classbdm_1_1SettingResolver.html#aadfcd0a81d025c52c8335b6aea07b498" title="Reference to a resolved link or to the original Setting in the case it does not contain...">result</a> is prepared for use. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac8b29999710e2db98c1a3979e25e6bbc"></a><!-- doxytag: member="bdm::SettingResolver::~SettingResolver" ref="ac8b29999710e2db98c1a3979e25e6bbc" args="()" -->
-&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1SettingResolver.html#ac8b29999710e2db98c1a3979e25e6bbc">~SettingResolver</a> ()</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">An opened <a class="el" href="classbdm_1_1UIFile.html" title="This class serves to load and/or save user-infos into/from configuration files stored...">UIFile</a> file is closed here if necessary. <br/></td></tr>
-<tr><td colspan="2"><h2>Public Attributes</h2></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aadfcd0a81d025c52c8335b6aea07b498"></a><!-- doxytag: member="bdm::SettingResolver::result" ref="aadfcd0a81d025c52c8335b6aea07b498" args="" -->
-const Setting &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1SettingResolver.html#aadfcd0a81d025c52c8335b6aea07b498">result</a></td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Reference to a resolved link or to the original Setting in the case it does not contain a link. <br/></td></tr>
-<tr><td colspan="2"><h2>Private Member Functions</h2></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aaf0e6941ba5919cae1bc530e2181b109"></a><!-- doxytag: member="bdm::SettingResolver::to_string" ref="aaf0e6941ba5919cae1bc530e2181b109" args="()" -->
-virtual string&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#aaf0e6941ba5919cae1bc530e2181b109">to_string</a> ()</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method returns a basic info about the current instance. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0551e3121091c5199bf4413b50522176"></a><!-- doxytag: member="bdm::SettingResolver::from_setting" ref="a0551e3121091c5199bf4413b50522176" args="(const Setting &amp;set)" -->
-virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#a0551e3121091c5199bf4413b50522176">from_setting</a> (const Setting &amp;set)</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method arrange instance properties according the data stored in the Setting structure. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a67d954d255ede776eade7334d4895790"></a><!-- doxytag: member="bdm::SettingResolver::to_setting" ref="a67d954d255ede776eade7334d4895790" args="(Setting &amp;set) const " -->
-virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#a67d954d255ede776eade7334d4895790">to_setting</a> (Setting &amp;set) const </td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method save all the instance properties into the Setting structure. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1c314bd6d6dacb8ba78ea5eb88fd9516"></a><!-- doxytag: member="bdm::SettingResolver::validate" ref="a1c314bd6d6dacb8ba78ea5eb88fd9516" args="()" -->
-virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#a1c314bd6d6dacb8ba78ea5eb88fd9516">validate</a> ()</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method TODO. <br/></td></tr>
-</table>
 <hr/><a name="_details"></a><h2>Detailed Description</h2>
 <p>This class serves to expand links used within configuration files. </p>
@@ -147,4 +117,34 @@
 </pre></div><p>The whole point is that a resolved link (class member <a class="el" href="classbdm_1_1SettingResolver.html#aadfcd0a81d025c52c8335b6aea07b498" title="Reference to a resolved link or to the original Setting in the case it does not contain...">result</a>, i.e., "link.result" in the previous example) could point into a different configuration file. In that case there has to be an <a class="el" href="classbdm_1_1UIFile.html" title="This class serves to load and/or save user-infos into/from configuration files stored...">UIFile</a> instance managing reading from this file. As the libconfig::Config deletes all its Settings when dealocated, <a class="el" href="classbdm_1_1UIFile.html" title="This class serves to load and/or save user-infos into/from configuration files stored...">UIFile</a> must not be dealocated until all the necessary operation on the linked Setting are finished (otherwise, the link <a class="el" href="classbdm_1_1SettingResolver.html#aadfcd0a81d025c52c8335b6aea07b498" title="Reference to a resolved link or to the original Setting in the case it does not contain...">result</a> would be invalid just after the <a class="el" href="classbdm_1_1UIFile.html" title="This class serves to load and/or save user-infos into/from configuration files stored...">UIFile</a> dealocation). And that is exactly the mechanism implemented within <a class="el" href="classbdm_1_1SettingResolver.html" title="This class serves to expand links used within configuration files.">SettingResolver</a> class. It assures, that the <a class="el" href="classbdm_1_1SettingResolver.html#aadfcd0a81d025c52c8335b6aea07b498" title="Reference to a resolved link or to the original Setting in the case it does not contain...">result</a> Setting reference is valid within the scope of <a class="el" href="classbdm_1_1SettingResolver.html" title="This class serves to expand links used within configuration files.">SettingResolver</a> instance.</p>
 <p><a class="el" href="ui_page.html">User Infos and their use</a> </p>
+
+<p><code>#include &lt;<a class="el" href="user__info_8h_source.html">user_info.h</a>&gt;</code></p>
+
+<p><a href="classbdm_1_1SettingResolver-members.html">List of all members.</a></p>
+<table border="0" cellpadding="0" cellspacing="0">
+<tr><td colspan="2"><h2>Public Member Functions</h2></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae2299746b95bf8af54a867aaf52fc8da"></a><!-- doxytag: member="bdm::SettingResolver::SettingResolver" ref="ae2299746b95bf8af54a867aaf52fc8da" args="(const Setting &amp;potential_link)" -->
+&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1SettingResolver.html#ae2299746b95bf8af54a867aaf52fc8da">SettingResolver</a> (const Setting &amp;potential_link)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">If potential_link contains a link to some other setting, it is resolved here. Anyway, the Setting reference <a class="el" href="classbdm_1_1SettingResolver.html#aadfcd0a81d025c52c8335b6aea07b498" title="Reference to a resolved link or to the original Setting in the case it does not contain...">result</a> is prepared for use. <br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac8b29999710e2db98c1a3979e25e6bbc"></a><!-- doxytag: member="bdm::SettingResolver::~SettingResolver" ref="ac8b29999710e2db98c1a3979e25e6bbc" args="()" -->
+&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1SettingResolver.html#ac8b29999710e2db98c1a3979e25e6bbc">~SettingResolver</a> ()</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">An opened <a class="el" href="classbdm_1_1UIFile.html" title="This class serves to load and/or save user-infos into/from configuration files stored...">UIFile</a> file is closed here if necessary. <br/></td></tr>
+<tr><td colspan="2"><h2>Public Attributes</h2></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aadfcd0a81d025c52c8335b6aea07b498"></a><!-- doxytag: member="bdm::SettingResolver::result" ref="aadfcd0a81d025c52c8335b6aea07b498" args="" -->
+const Setting &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1SettingResolver.html#aadfcd0a81d025c52c8335b6aea07b498">result</a></td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Reference to a resolved link or to the original Setting in the case it does not contain a link. <br/></td></tr>
+<tr><td colspan="2"><h2>Private Member Functions</h2></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aaf0e6941ba5919cae1bc530e2181b109"></a><!-- doxytag: member="bdm::SettingResolver::to_string" ref="aaf0e6941ba5919cae1bc530e2181b109" args="()" -->
+virtual string&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#aaf0e6941ba5919cae1bc530e2181b109">to_string</a> ()</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method returns a basic info about the current instance. <br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0551e3121091c5199bf4413b50522176"></a><!-- doxytag: member="bdm::SettingResolver::from_setting" ref="a0551e3121091c5199bf4413b50522176" args="(const Setting &amp;set)" -->
+virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#a0551e3121091c5199bf4413b50522176">from_setting</a> (const Setting &amp;set)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method arrange instance properties according the data stored in the Setting structure. <br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a67d954d255ede776eade7334d4895790"></a><!-- doxytag: member="bdm::SettingResolver::to_setting" ref="a67d954d255ede776eade7334d4895790" args="(Setting &amp;set) const " -->
+virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#a67d954d255ede776eade7334d4895790">to_setting</a> (Setting &amp;set) const </td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method save all the instance properties into the Setting structure. <br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1c314bd6d6dacb8ba78ea5eb88fd9516"></a><!-- doxytag: member="bdm::SettingResolver::validate" ref="a1c314bd6d6dacb8ba78ea5eb88fd9516" args="()" -->
+virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#a1c314bd6d6dacb8ba78ea5eb88fd9516">validate</a> ()</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method TODO. <br/></td></tr>
+</table>
 <hr/>The documentation for this class was generated from the following files:<ul>
 <li><a class="el" href="user__info_8h_source.html">user_info.h</a></li>
@@ -152,5 +152,5 @@
 </ul>
 </div>
-<hr size="1"/><address style="text-align: right;"><small>Generated on Sun Sep 13 22:40:43 2009 for mixpp by&nbsp;
+<hr size="1"/><address style="text-align: right;"><small>Generated on Sun Sep 13 23:08:56 2009 for mixpp by&nbsp;
 <a href="http://www.doxygen.org/index.html">
 <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>