Index: library/doc/html/classbdm_1_1mlognorm.html
===================================================================
--- library/doc/html/classbdm_1_1mlognorm.html (revision 617)
+++ library/doc/html/classbdm_1_1mlognorm.html (revision 621)
@@ -76,7 +76,5 @@
 <hr/><a name="_details"></a><h2>Detailed Description</h2>
 <p>Log-Normal random walk. </p>
-<p>Mean value, <img class="formulaInl" alt="$\mu$" src="form_83.png"/>, is...</p>
-<p>==== Check == vv = Standard deviation of the random walk is proportional to one <img class="formulaInl" alt="$k$" src="form_84.png"/>-th the mean. This is achieved by setting <img class="formulaInl" alt="$\alpha=k$" src="form_85.png"/> and <img class="formulaInl" alt="$\beta=k/\mu$" src="form_86.png"/>.</p>
-<p>The standard deviation of the walk is then: <img class="formulaInl" alt="$\mu/\sqrt(k)$" src="form_87.png"/>. </p>
+<p>Mean value, <img class="formulaInl" alt="$\mu$" src="form_83.png"/>, is... </p>
 
 <p><code>#include &lt;<a class="el" href="exp__family_8h_source.html">exp_family.h</a>&gt;</code></p>
@@ -182,21 +180,18 @@
 </div>
 <div class="memdoc">
-<p><a class="el" href="classbdm_1_1UI.html" title="UI is an abstract class which collects all the auxiliary functions useful to prepare...">UI</a> for <a class="el" href="classbdm_1_1mlognorm.html" title="Log-Normal random walk.">mlognorm</a></p>
-<p>The <a class="el" href="classbdm_1_1mlognorm.html" title="Log-Normal random walk.">mlognorm</a> is constructed from a structure with fields: </p>
-<div class="fragment"><pre class="fragment">                system = {
-                        type = <span class="stringliteral">&quot;mlognorm&quot;</span>;
-                        k = 0.1;                                  <span class="comment">// constant k</span>
-                        mu0 = [1., 1.];
-                        
-                        <span class="comment">// == OPTIONAL ==</span>
-                        <span class="comment">// description of y variables</span>
-                        y = {type=<span class="stringliteral">&quot;rv&quot;</span>; names=[<span class="stringliteral">&quot;y&quot;</span>, <span class="stringliteral">&quot;u&quot;</span>];};
-                        <span class="comment">// description of u variable</span>
-                        u = {type=<span class="stringliteral">&quot;rv&quot;</span>; names=[];}
-                };
+<p>Create logNormal random Walk </p>
+<p class="formulaDsp">
+<img class="formulaDsp" alt="\[ f(rv|rvc) = log\mathcal{N}( \log(rvc)-0.5\log(k^2+1), k I) \]" src="form_172.png"/>
+</p>
+<p> from structure </p>
+<div class="fragment"><pre class="fragment">                <span class="keyword">class </span>= &apos;<a class="code" href="classbdm_1_1mlognorm.html#aa5d6eb2688d02e0348b96c4fbd7bde41" title="Constructor.">mlognorm</a>&apos;;
+                k   = 0.1;               <span class="comment">// &quot;variance&quot; k</span>
+                mu0 = 0.1;               <span class="comment">// Initial value of mean</span>
+                rv  = RV({<span class="stringliteral">&apos;name&apos;</span>})       <span class="comment">// description of RV</span>
+                <a class="code" href="classbdm_1_1mpdf.html#a5a5f08950daa08b85b01ddf4e1c36288" title="random variable in condition">rvc</a> = RV({<span class="stringliteral">&apos;name&apos;</span>})       <span class="comment">// description of RV in condition</span>
 </pre></div> 
 <p>Reimplemented from <a class="el" href="classbdm_1_1mpdf.html#a30a0bceb948e287d497c578e371b1667">bdm::mpdf</a>.</p>
 
-<p>References <a class="el" href="exp__family_8h_source.html#l00956">condition()</a>, <a class="el" href="user__info_8h_source.html#l00443">bdm::UI::get()</a>, and <a class="el" href="exp__family_8h_source.html#l00949">set_parameters()</a>.</p>
+<p>References <a class="el" href="exp__family_8h_source.html#l00982">condition()</a>, <a class="el" href="user__info_8h_source.html#l00443">bdm::UI::get()</a>, and <a class="el" href="exp__family_8h_source.html#l00975">set_parameters()</a>.</p>
 
 </div>
@@ -207,5 +202,5 @@
 </ul>
 </div>
-<hr size="1"/><address style="text-align: right;"><small>Generated on Tue Sep 15 23:42:49 2009 for mixpp by&nbsp;
+<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Sep 16 22:33:34 2009 for mixpp by&nbsp;
 <a href="http://www.doxygen.org/index.html">
 <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>