Index: library/doc/html/classbdm_1_1ARX.html
===================================================================
--- library/doc/html/classbdm_1_1ARX.html (revision 621)
+++ library/doc/html/classbdm_1_1ARX.html (revision 632)
@@ -113,4 +113,7 @@
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set sufficient statistics. <br/></td></tr>
 <tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1ARX.html#a9637412df898048bafaefee9dc7e9f6c">from_setting</a> (const Setting &amp;set)</td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5b4ae27fa320a1b6e09777239210566d"></a><!-- doxytag: member="bdm::ARX::validate" ref="a5b4ae27fa320a1b6e09777239210566d" args="()" -->
+void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1ARX.html#a5b4ae27fa320a1b6e09777239210566d">validate</a> ()</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method TODO. <br/></td></tr>
 <tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad2b528b7a41ca67163152142f5404051"></a><!-- doxytag: member="bdm::ARX::set_statistics" ref="ad2b528b7a41ca67163152142f5404051" args="(const BMEF *BM0)" -->
 virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1BMEF.html#ad2b528b7a41ca67163152142f5404051">set_statistics</a> (const <a class="el" href="classbdm_1_1BMEF.html">BMEF</a> *BM0)</td></tr>
@@ -125,7 +128,4 @@
 virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#a67d954d255ede776eade7334d4895790">to_setting</a> (Setting &amp;set) const </td></tr>
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method save all the instance properties into the Setting structure. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1c314bd6d6dacb8ba78ea5eb88fd9516"></a><!-- doxytag: member="bdm::ARX::validate" ref="a1c314bd6d6dacb8ba78ea5eb88fd9516" args="()" -->
-virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#a1c314bd6d6dacb8ba78ea5eb88fd9516">validate</a> ()</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method TODO. <br/></td></tr>
 <tr><td colspan="2"><div class="groupHeader">Constructors</div></td></tr>
 <tr><td colspan="2"><div class="groupText"><p><a class="anchor" id="amgrp559a25fdb98a7d1fd1c3771ac568d5e9"></a> </p>
@@ -157,6 +157,7 @@
 <a class="el" href="classbdm_1_1enorm.html">enorm</a>&lt; <a class="el" href="classbdm_1_1ldmat.html">ldmat</a> &gt; *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1ARX.html#a4cdf5e2a7d3480ec31f6247ed4289b15">epredictor</a> () const </td></tr>
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Predictor for empty regressor. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classbdm_1_1mlnorm.html">mlnorm</a>&lt; <a class="el" href="classbdm_1_1ldmat.html">ldmat</a> &gt; *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1ARX.html#a74fe8ae2d88bee8639510fd0eaf73513">predictor</a> () const </td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">conditional version of the predictor  <a href="#a74fe8ae2d88bee8639510fd0eaf73513"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a74fe8ae2d88bee8639510fd0eaf73513"></a><!-- doxytag: member="bdm::ARX::predictor" ref="a74fe8ae2d88bee8639510fd0eaf73513" args="() const " -->
+<a class="el" href="classbdm_1_1mlnorm.html">mlnorm</a>&lt; <a class="el" href="classbdm_1_1ldmat.html">ldmat</a> &gt; *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1ARX.html#a74fe8ae2d88bee8639510fd0eaf73513">predictor</a> () const </td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">conditional version of the predictor <br/></td></tr>
 <tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac6a2428a46407fe45b4c7a99069c0801"></a><!-- doxytag: member="bdm::ARX::predictor_student" ref="ac6a2428a46407fe45b4c7a99069c0801" args="() const " -->
 <a class="el" href="classbdm_1_1mlstudent.html">mlstudent</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><b>predictor_student</b> () const </td></tr>
@@ -173,6 +174,6 @@
 <tr><td colspan="2"><div class="groupText"><p><a class="anchor" id="amgrpc2cc7082a89c1ad6631a2f66af5f00c0"></a> </p>
 <br/><br/></div></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="adf3dc1b90efc0cc54a3a6e5e858542d1"></a><!-- doxytag: member="bdm::ARX::set_drv" ref="adf3dc1b90efc0cc54a3a6e5e858542d1" args="(const RV &amp;drv0)" -->
-void&nbsp;</td><td class="memItemRight" valign="bottom"><b>set_drv</b> (const <a class="el" href="classbdm_1_1RV.html">RV</a> &amp;drv0)</td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af357c693b640fc0094e3bd56f180ff94"></a><!-- doxytag: member="bdm::ARX::set_rv" ref="af357c693b640fc0094e3bd56f180ff94" args="(const RV &amp;yrv0, const RV &amp;rgrrv0)" -->
+void&nbsp;</td><td class="memItemRight" valign="bottom"><b>set_rv</b> (const <a class="el" href="classbdm_1_1RV.html">RV</a> &amp;yrv0, const <a class="el" href="classbdm_1_1RV.html">RV</a> &amp;rgrrv0)</td></tr>
 <tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7b96872783ab72e135b7b9ee26ef0577"></a><!-- doxytag: member="bdm::ARX::get_yrv" ref="a7b96872783ab72e135b7b9ee26ef0577" args="()" -->
 <a class="el" href="classbdm_1_1RV.html">RV</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><b>get_yrv</b> ()</td></tr>
@@ -191,4 +192,6 @@
 <tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aff2d8755ba0b3def927d31305c03b09c"></a><!-- doxytag: member="bdm::ARX::_drv" ref="aff2d8755ba0b3def927d31305c03b09c" args="() const " -->
 const <a class="el" href="classbdm_1_1RV.html">RV</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><b>_drv</b> () const </td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af135ae6dce7e9f30c9f88229c7930b96"></a><!-- doxytag: member="bdm::ARX::set_drv" ref="af135ae6dce7e9f30c9f88229c7930b96" args="(const RV &amp;rv)" -->
+void&nbsp;</td><td class="memItemRight" valign="bottom"><b>set_drv</b> (const <a class="el" href="classbdm_1_1RV.html">RV</a> &amp;rv)</td></tr>
 <tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab38d92f17620813ad872d86e01a26e5e"></a><!-- doxytag: member="bdm::ARX::set_rv" ref="ab38d92f17620813ad872d86e01a26e5e" args="(const RV &amp;rv)" -->
 void&nbsp;</td><td class="memItemRight" valign="bottom"><b>set_rv</b> (const <a class="el" href="classbdm_1_1RV.html">RV</a> &amp;rv)</td></tr>
@@ -202,4 +205,7 @@
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">size of output variable (needed in regressors) <br/></td></tr>
 <tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classbdm_1_1RV.html">RV</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1ARX.html#a363aaa55b2ab3eec602510cdf53e84ef">_yrv</a></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a320ac7b3b511bc4b26e8f8823026a453"></a><!-- doxytag: member="bdm::ARX::rgrrv" ref="a320ac7b3b511bc4b26e8f8823026a453" args="" -->
+<a class="el" href="classbdm_1_1RV.html">RV</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1ARX.html#a320ac7b3b511bc4b26e8f8823026a453">rgrrv</a></td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">rv of regressor <br/></td></tr>
 <tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a11474a627367f81b76830cb8477cf026"></a><!-- doxytag: member="bdm::ARX::est" ref="a11474a627367f81b76830cb8477cf026" args="" -->
 <a class="el" href="classbdm_1_1egiw.html">egiw</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1ARX.html#a11474a627367f81b76830cb8477cf026">est</a></td></tr>
@@ -211,4 +217,10 @@
 double &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1ARX.html#a740b0582f180ba13cae91d66e9bdb67f">nu</a></td></tr>
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">cached value of est.nu <br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6dcf8458bdc25d831542c6da89961fbc"></a><!-- doxytag: member="bdm::ARX::have_constant" ref="a6dcf8458bdc25d831542c6da89961fbc" args="" -->
+bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1ARX.html#a6dcf8458bdc25d831542c6da89961fbc">have_constant</a></td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">switch if constant is modelled or not <br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8f87c2958e5690610fed2992d6ffe5c0"></a><!-- doxytag: member="bdm::ARX::_dt" ref="a8f87c2958e5690610fed2992d6ffe5c0" args="" -->
+vec&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1ARX.html#a8f87c2958e5690610fed2992d6ffe5c0">_dt</a></td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">cached value of data vector for have_constant =true <br/></td></tr>
 <tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1331865e10fb1ccef65bb4c47fa3be64"></a><!-- doxytag: member="bdm::ARX::frg" ref="a1331865e10fb1ccef65bb4c47fa3be64" args="" -->
 double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1BMEF.html#a1331865e10fb1ccef65bb4c47fa3be64">frg</a></td></tr>
@@ -324,22 +336,23 @@
 <div class="memdoc">
 <p><a class="el" href="classbdm_1_1UI.html" title="UI is an abstract class which collects all the auxiliary functions useful to prepare...">UI</a> for <a class="el" href="classbdm_1_1ARX.html" title="Linear Autoregressive model with Gaussian noise.">ARX</a> estimator</p>
-<p>The <a class="el" href="classbdm_1_1ARX.html" title="Linear Autoregressive model with Gaussian noise.">ARX</a> is constructed from a structure with fields: </p>
-<div class="fragment"><pre class="fragment">        estimator = {
-                <span class="keyword">class </span>= &quot;ARX&quot;;
-                y = {type=<span class="stringliteral">&quot;rv&quot;</span>, ...}   <span class="comment">// description of output variables</span>
-                rgr = {type=<span class="stringliteral">&quot;rv&quot;</span>, ...} <span class="comment">// description of regressor variables</span>
-                constant = <span class="keyword">true</span>;       <span class="comment">// boolean switch if the constant term is modelled or not</span>
-
-                <span class="comment">//optional fields</span>
-                dV0 = [1e-3, 1e-5, 1e-5, 1e-5];
-                                                           <span class="comment">// default: 1e-3 for y, 1e-5 for rgr</span>
-                nu0 = 6;               <span class="comment">// default: rgrlen + 2</span>
-                <a class="code" href="classbdm_1_1BMEF.html#a1331865e10fb1ccef65bb4c47fa3be64" title="forgetting factor">frg</a> = 1.0;             <span class="comment">// forgetting, default frg=1.0</span>
-        };
-</pre></div><p>The estimator will assign names of the posterior in the form ["theta_i" and "r_i"] </p>
-
+<div class="fragment"><pre class="fragment">        <span class="keyword">class </span>= &apos;ARX&apos;;
+        rv    = RV({names_of_dt} )                 <span class="comment">// description of output variables</span>
+        rgr   = RV({names_of_regressors}, [-1,-2]} <span class="comment">// description of regressor variables</span>
+        constant = 1;                              <span class="comment">// 0/1 switch if the constant term is modelled or not</span>
+
+        --- optional ---
+        V0  = [1 0;0 1];                           <span class="comment">// Initial value of information matrix V</span>
+          --- OR ---
+        dV0 = [1e-3, 1e-5, 1e-5, 1e-5];            <span class="comment">// Initial value of diagonal of information matrix V</span>
+                                                                                           <span class="comment">// default: 1e-3 for rv, 1e-5 for rgr</span>
+        nu0 = 6;                                                   <span class="comment">// initial value of nu, default: rgrlen + 2</span>
+        <a class="code" href="classbdm_1_1BMEF.html#a1331865e10fb1ccef65bb4c47fa3be64" title="forgetting factor">frg</a> = 1.0;                                 <span class="comment">// forgetting, default frg=1.0</span>
+
+        rv_param   = RV({names_of_parameters}}     <span class="comment">// description of parametetr names </span>
+                                                                                           <span class="comment">// default: [&quot;theta_i&quot; and &quot;r_i&quot;]</span>
+</pre></div> 
 <p>Reimplemented from <a class="el" href="classbdm_1_1BM.html#a23c6a8f71f922023ab08dcb0487a86de">bdm::BM</a>.</p>
 
-<p>References <a class="el" href="exp__family_8h_source.html#l00084">bdm::BMEF::frg</a>, <a class="el" href="user__info_8h_source.html#l00443">bdm::UI::get()</a>, and <a class="el" href="bdmbase_8h_source.html#l01161">bdm::BM::set_options()</a>.</p>
+<p>References <a class="el" href="arx_8h_source.html#l00061">_dt</a>, <a class="el" href="arx_8h_source.html#l00053">est</a>, <a class="el" href="exp__family_8h_source.html#l00084">bdm::BMEF::frg</a>, <a class="el" href="user__info_8h_source.html#l00443">bdm::UI::get()</a>, <a class="el" href="arx_8h_source.html#l00059">have_constant</a>, <a class="el" href="bdmbase_8h_source.html#l01163">bdm::BM::set_options()</a>, <a class="el" href="bdmbase_8h_source.html#l00414">bdm::epdf::set_rv()</a>, and <a class="el" href="arx_8h_source.html#l00169">validate()</a>.</p>
 
 </div>
@@ -364,31 +377,5 @@
 <p>Reimplemented from <a class="el" href="classbdm_1_1BM.html#a50257e0c1e5b5c73153ea6e716ad8ae0">bdm::BM</a>.</p>
 
-<p>References <a class="el" href="arx_8h_source.html#l00051">est</a>, <a class="el" href="bdmbase_8h_source.html#l01061">bdm::BM::evalll</a>, <a class="el" href="exp__family_8h_source.html#l00084">bdm::BMEF::frg</a>, <a class="el" href="exp__family_8h_source.html#l00086">bdm::BMEF::last_lognc</a>, <a class="el" href="exp__family_8cpp_source.html#l00050">bdm::egiw::lognc()</a>, <a class="el" href="arx_8h_source.html#l00055">nu</a>, <a class="el" href="square__mat_8cpp_source.html#l00074">bdm::ldmat::opupdt()</a>, <a class="el" href="exp__family_8h_source.html#l00249">bdm::egiw::pow()</a>, and <a class="el" href="arx_8h_source.html#l00053">V</a>.</p>
-
-</div>
-</div>
-<a class="anchor" id="a74fe8ae2d88bee8639510fd0eaf73513"></a><!-- doxytag: member="bdm::ARX::predictor" ref="a74fe8ae2d88bee8639510fd0eaf73513" args="() const " -->
-<div class="memitem">
-<div class="memproto">
-      <table class="memname">
-        <tr>
-          <td class="memname"><a class="el" href="classbdm_1_1mlnorm.html">mlnorm</a>&lt; <a class="el" href="classbdm_1_1ldmat.html">ldmat</a> &gt; * bdm::ARX::predictor </td>
-          <td>(</td>
-          <td class="paramname"></td>
-          <td>&nbsp;)&nbsp;</td>
-          <td> const<code> [virtual]</code></td>
-        </tr>
-      </table>
-</div>
-<div class="memdoc">
-
-<p>conditional version of the predictor </p>
-
-<p><p>&lt;----------- TODO </p>
-</p>
-
-<p>Reimplemented from <a class="el" href="classbdm_1_1BM.html#a598b25e3f3d96a5bc00a5faeb5b3c912">bdm::BM</a>.</p>
-
-<p>References <a class="el" href="bdmerror_8h_source.html#l00047">bdm_assert_debug</a>, <a class="el" href="bdmbase_8h_source.html#l00437">bdm::epdf::dimension()</a>, <a class="el" href="arx_8h_source.html#l00051">est</a>, <a class="el" href="exp__family_8cpp_source.html#l00145">bdm::egiw::mean_mat()</a>, <a class="el" href="square__mat_8h_source.html#l00100">bdm::sqmat::rows()</a>, <a class="el" href="exp__family_8h_source.html#l00586">bdm::mlnorm&lt; sq_T, TEpdf &gt;::set_parameters()</a>, and <a class="el" href="arx_8h_source.html#l00053">V</a>.</p>
+<p>References <a class="el" href="arx_8h_source.html#l00053">est</a>, <a class="el" href="bdmbase_8h_source.html#l01063">bdm::BM::evalll</a>, <a class="el" href="exp__family_8h_source.html#l00084">bdm::BMEF::frg</a>, <a class="el" href="exp__family_8h_source.html#l00086">bdm::BMEF::last_lognc</a>, <a class="el" href="exp__family_8cpp_source.html#l00064">bdm::egiw::lognc()</a>, <a class="el" href="arx_8h_source.html#l00057">nu</a>, <a class="el" href="square__mat_8cpp_source.html#l00074">bdm::ldmat::opupdt()</a>, <a class="el" href="exp__family_8h_source.html#l00237">bdm::egiw::pow()</a>, and <a class="el" href="arx_8h_source.html#l00055">V</a>.</p>
 
 </div>
@@ -413,5 +400,5 @@
 <dl class="return"><dt><b>Returns:</b></dt><dd>indeces of accepted regressors. </dd></dl>
 
-<p>References <a class="el" href="bdmbase_8h_source.html#l00437">bdm::epdf::dimension()</a>, <a class="el" href="arx_8h_source.html#l00051">est</a>, and <a class="el" href="exp__family_8cpp_source.html#l00050">bdm::egiw::lognc()</a>.</p>
+<p>References <a class="el" href="bdmbase_8h_source.html#l00435">bdm::epdf::dimension()</a>, <a class="el" href="arx_8h_source.html#l00053">est</a>, and <a class="el" href="exp__family_8cpp_source.html#l00064">bdm::egiw::lognc()</a>.</p>
 
 </div>
@@ -450,4 +437,6 @@
 <div class="memdoc">
 <p>description of modelled data <img class="formulaInl" alt="$ y_t $" src="form_6.png"/> in the likelihood function Do NOT access directly, only via <code>get_yrv()</code>. </p>
+
+<p>Referenced by <a class="el" href="arx_8h_source.html#l00169">validate()</a>.</p>
 
 </div>
@@ -458,5 +447,5 @@
 </ul>
 </div>
-<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Sep 16 22:33:33 2009 for mixpp by&nbsp;
+<hr size="1"/><address style="text-align: right;"><small>Generated on Fri Sep 18 00:12:04 2009 for mixpp by&nbsp;
 <a href="http://www.doxygen.org/index.html">
 <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>