Index: library/doc/html/classbdm_1_1MPF.html
===================================================================
--- library/doc/html/classbdm_1_1MPF.html (revision 632)
+++ library/doc/html/classbdm_1_1MPF.html (revision 641)
@@ -3,5 +3,5 @@
 <head>
 <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
-<title>mixpp: bdm::MPF&lt; BM_T &gt; Class Template Reference</title>
+<title>mixpp: bdm::MPF Class Reference</title>
 <link href="tabs.css" rel="stylesheet" type="text/css"/>
 <link href="doxygen.css" rel="stylesheet" type="text/css"/>
@@ -71,13 +71,10 @@
 </div>
 <div class="contents">
-<h1>bdm::MPF&lt; BM_T &gt; Class Template Reference</h1><!-- doxytag: class="bdm::MPF" --><!-- doxytag: inherits="bdm::PF" -->
+<h1>bdm::MPF Class Reference</h1><!-- doxytag: class="bdm::MPF" --><!-- doxytag: inherits="bdm::BM" -->
 <p>Marginalized Particle filter.  
 <a href="#_details">More...</a></p>
 <hr/><a name="_details"></a><h2>Detailed Description</h2>
-<h3>template&lt;class BM_T&gt;<br/>
- class bdm::MPF&lt; BM_T &gt;</h3>
-
 <p>Marginalized Particle filter. </p>
-<p>Trivial version: proposal = parameter evolution, observation model is not used. (it is assumed to be part of <a class="el" href="classbdm_1_1BM.html" title="Bayesian Model of a system, i.e. all uncertainty is modeled by probabilities.">BM</a>). </p>
+<p>A composition of particle filter with exact (or almost exact) bayesian models (BMs). The Bayesian models provide marginalized predictive density. Internaly this is achieved by virtual class MPFmpdf. </p>
 
 <p><code>#include &lt;<a class="el" href="particles_8h_source.html">particles.h</a>&gt;</code></p>
@@ -89,27 +86,23 @@
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">internal class for MPDF providing composition of <a class="el" href="classbdm_1_1eEmp.html" title="Weighted empirical density.">eEmp</a> with external components <br/></td></tr>
 <tr><td colspan="2"><h2>Public Member Functions</h2></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0068e7ca53d90fa5911eb31a0d657f26"></a><!-- doxytag: member="bdm::MPF::MPF" ref="a0068e7ca53d90fa5911eb31a0d657f26" args="()" -->
-&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1MPF.html#a0068e7ca53d90fa5911eb31a0d657f26">MPF</a> ()</td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af45da512c659b40b21a74492a0c06853"></a><!-- doxytag: member="bdm::MPF::MPF" ref="af45da512c659b40b21a74492a0c06853" args="()" -->
+&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1MPF.html#af45da512c659b40b21a74492a0c06853">MPF</a> ()</td></tr>
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Default constructor. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae082d7ea1694624644cedc837b067f22"></a><!-- doxytag: member="bdm::MPF::set_parameters" ref="ae082d7ea1694624644cedc837b067f22" args="(mpdf *par0, mpdf *obs0, int n0, RESAMPLING_METHOD rm=SYSTEMATIC)" -->
-void&nbsp;</td><td class="memItemRight" valign="bottom"><b>set_parameters</b> (<a class="el" href="classbdm_1_1mpdf.html">mpdf</a> *par0, <a class="el" href="classbdm_1_1mpdf.html">mpdf</a> *obs0, int n0, RESAMPLING_METHOD rm=SYSTEMATIC)</td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="afe145d1b5f32b0c57b5202f264e48a4f"></a><!-- doxytag: member="bdm::MPF::set_statistics" ref="afe145d1b5f32b0c57b5202f264e48a4f" args="(const epdf &amp;epdf0, const BM_T *BMcond0)" -->
-void&nbsp;</td><td class="memItemRight" valign="bottom"><b>set_statistics</b> (const <a class="el" href="classbdm_1_1epdf.html">epdf</a> &amp;epdf0, const BM_T *BMcond0)</td></tr>
-<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1MPF.html#a286d040770d08bd7ff416cea617b1b14">bayes</a> (const vec &amp;dt)</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Incremental Bayes rule.  <a href="#a286d040770d08bd7ff416cea617b1b14"></a><br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a25d5dc30b1260b07edb6183bdd73ef16"></a><!-- doxytag: member="bdm::MPF::posterior" ref="a25d5dc30b1260b07edb6183bdd73ef16" args="() const " -->
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="acea07b8861bcd1a82b63cc9c7383fbfd"></a><!-- doxytag: member="bdm::MPF::set_parameters" ref="acea07b8861bcd1a82b63cc9c7383fbfd" args="(shared_ptr&lt; mpdf &gt; par0, shared_ptr&lt; mpdf &gt; obs0, int n0, RESAMPLING_METHOD rm=SYSTEMATIC)" -->
+void&nbsp;</td><td class="memItemRight" valign="bottom"><b>set_parameters</b> (<a class="el" href="classbdm_1_1shared__ptr.html">shared_ptr</a>&lt; <a class="el" href="classbdm_1_1mpdf.html">mpdf</a> &gt; par0, <a class="el" href="classbdm_1_1shared__ptr.html">shared_ptr</a>&lt; <a class="el" href="classbdm_1_1mpdf.html">mpdf</a> &gt; obs0, int n0, RESAMPLING_METHOD rm=SYSTEMATIC)</td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac3ecf10c8f2e9114c7a57f122890aa9a"></a><!-- doxytag: member="bdm::MPF::set_BM" ref="ac3ecf10c8f2e9114c7a57f122890aa9a" args="(const BM &amp;BMcond0)" -->
+void&nbsp;</td><td class="memItemRight" valign="bottom"><b>set_BM</b> (const <a class="el" href="classbdm_1_1BM.html">BM</a> &amp;BMcond0)</td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1MPF.html#a0fbe47b20c491f25030ef2875c148892">bayes</a> (const vec &amp;dt)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Incremental Bayes rule.  <a href="#a0fbe47b20c491f25030ef2875c148892"></a><br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4f4cd8060351dc1a344974e86ffb876b"></a><!-- doxytag: member="bdm::MPF::posterior" ref="a4f4cd8060351dc1a344974e86ffb876b" args="() const " -->
 const <a class="el" href="classbdm_1_1epdf.html">epdf</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><b>posterior</b> () const </td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2e95498dec734088ab9f4878ff404144"></a><!-- doxytag: member="bdm::MPF::set_options" ref="a2e95498dec734088ab9f4878ff404144" args="(const string &amp;opt)" -->
-void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1MPF.html#a2e95498dec734088ab9f4878ff404144">set_options</a> (const string &amp;opt)</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set postrior of <code>rvc</code> to samples from epdf0. Statistics of BMs are not re-computed! Use only for initialization! <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab6e7b094cbe32944b8ccde5df73cd839"></a><!-- doxytag: member="bdm::MPF::_BM" ref="ab6e7b094cbe32944b8ccde5df73cd839" args="(int i)" -->
-const <a class="el" href="classbdm_1_1BM.html">BM</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1MPF.html#ab6e7b094cbe32944b8ccde5df73cd839">_BM</a> (int i)</td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1MPF.html#aada1bdb117bc78035fbb49765fa7ef10">set_options</a> (const string &amp;opt)</td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a71608a6986f57dcfb935e016b97c0637"></a><!-- doxytag: member="bdm::MPF::_BM" ref="a71608a6986f57dcfb935e016b97c0637" args="(int i)" -->
+const <a class="el" href="classbdm_1_1BM.html">BM</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1MPF.html#a71608a6986f57dcfb935e016b97c0637">_BM</a> (int i)</td></tr>
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Access function. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a78a9f6809827be1d9bfe215d03b1c6ed"></a><!-- doxytag: member="bdm::MPF::__w" ref="a78a9f6809827be1d9bfe215d03b1c6ed" args="()" -->
-vec *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1PF.html#a78a9f6809827be1d9bfe215d03b1c6ed">__w</a> ()</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">access function <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a23c6a8f71f922023ab08dcb0487a86de"></a><!-- doxytag: member="bdm::MPF::from_setting" ref="a23c6a8f71f922023ab08dcb0487a86de" args="(const Setting &amp;set)" -->
-void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1BM.html#a23c6a8f71f922023ab08dcb0487a86de">from_setting</a> (const Setting &amp;set)</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method arrange instance properties according the data stored in the Setting structure. <br/></td></tr>
+<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1MPF.html#a9f74326b9ca3c888cb8eff1355ba3670">from_setting</a> (const Setting &amp;set)</td></tr>
+<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa91b588de1b9690ca475c945d0f10f08"></a><!-- doxytag: member="bdm::MPF::validate" ref="aa91b588de1b9690ca475c945d0f10f08" args="()" -->
+void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1MPF.html#aa91b588de1b9690ca475c945d0f10f08">validate</a> ()</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method TODO. <br/></td></tr>
 <tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aaf0e6941ba5919cae1bc530e2181b109"></a><!-- doxytag: member="bdm::MPF::to_string" ref="aaf0e6941ba5919cae1bc530e2181b109" args="()" -->
 virtual string&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#aaf0e6941ba5919cae1bc530e2181b109">to_string</a> ()</td></tr>
@@ -118,12 +111,4 @@
 virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#a67d954d255ede776eade7334d4895790">to_setting</a> (Setting &amp;set) const </td></tr>
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method save all the instance properties into the Setting structure. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1c314bd6d6dacb8ba78ea5eb88fd9516"></a><!-- doxytag: member="bdm::MPF::validate" ref="a1c314bd6d6dacb8ba78ea5eb88fd9516" args="()" -->
-virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#a1c314bd6d6dacb8ba78ea5eb88fd9516">validate</a> ()</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method TODO. <br/></td></tr>
-<tr><td colspan="2"><div class="groupHeader">Constructors</div></td></tr>
-<tr><td colspan="2"><div class="groupText"><p><a class="anchor" id="amgrp559a25fdb98a7d1fd1c3771ac568d5e9"></a> </p>
-<br/><br/></div></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac9a4df02d81ad3559caebeed74b16167"></a><!-- doxytag: member="bdm::MPF::set_statistics" ref="ac9a4df02d81ad3559caebeed74b16167" args="(const vec w0, const epdf &amp;epdf0)" -->
-void&nbsp;</td><td class="memItemRight" valign="bottom"><b>set_statistics</b> (const vec w0, const <a class="el" href="classbdm_1_1epdf.html">epdf</a> &amp;epdf0)</td></tr>
 <tr><td colspan="2"><div class="groupHeader">Constructors</div></td></tr>
 <tr><td colspan="2"><div class="groupText"><p><a class="anchor" id="amgrp559a25fdb98a7d1fd1c3771ac568d5e9"></a> </p>
@@ -160,25 +145,4 @@
 void&nbsp;</td><td class="memItemRight" valign="bottom"><b>set_evalll</b> (bool evl0)</td></tr>
 <tr><td colspan="2"><h2>Protected Attributes</h2></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aeeafaf9b8ad75fe62ee9fd6369e3f7fe"></a><!-- doxytag: member="bdm::MPF::n" ref="aeeafaf9b8ad75fe62ee9fd6369e3f7fe" args="" -->
-int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1PF.html#aeeafaf9b8ad75fe62ee9fd6369e3f7fe">n</a></td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">number of particles; <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="adc049265b9086cad7071f98d00a2b9af"></a><!-- doxytag: member="bdm::MPF::est" ref="adc049265b9086cad7071f98d00a2b9af" args="" -->
-<a class="el" href="classbdm_1_1eEmp.html">eEmp</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1PF.html#adc049265b9086cad7071f98d00a2b9af">est</a></td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">posterior density <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af5149d5522d1095d39240c4c607f61a3"></a><!-- doxytag: member="bdm::MPF::_w" ref="af5149d5522d1095d39240c4c607f61a3" args="" -->
-vec &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1PF.html#af5149d5522d1095d39240c4c607f61a3">_w</a></td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">pointer into <code><a class="el" href="classbdm_1_1eEmp.html" title="Weighted empirical density.">eEmp</a></code> <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a914bd66025692c4018dbd482cb3c47c1"></a><!-- doxytag: member="bdm::MPF::_samples" ref="a914bd66025692c4018dbd482cb3c47c1" args="" -->
-Array&lt; vec &gt; &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1PF.html#a914bd66025692c4018dbd482cb3c47c1">_samples</a></td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">pointer into <code><a class="el" href="classbdm_1_1eEmp.html" title="Weighted empirical density.">eEmp</a></code> <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a521e9621d3b5e1274275f323691afdaf"></a><!-- doxytag: member="bdm::MPF::par" ref="a521e9621d3b5e1274275f323691afdaf" args="" -->
-<a class="el" href="classbdm_1_1mpdf.html">mpdf</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1PF.html#a521e9621d3b5e1274275f323691afdaf">par</a></td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Parameter evolution model. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad6e7a62fba1e0a0d73c9b87f4fb683ec"></a><!-- doxytag: member="bdm::MPF::obs" ref="ad6e7a62fba1e0a0d73c9b87f4fb683ec" args="" -->
-<a class="el" href="classbdm_1_1mpdf.html">mpdf</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1PF.html#ad6e7a62fba1e0a0d73c9b87f4fb683ec">obs</a></td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Observation model. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9932c7c5865954ef9a438afcbe944e52"></a><!-- doxytag: member="bdm::MPF::resmethod" ref="a9932c7c5865954ef9a438afcbe944e52" args="" -->
-RESAMPLING_METHOD&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1PF.html#a9932c7c5865954ef9a438afcbe944e52">resmethod</a></td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">which resampling method will be used <br/></td></tr>
 <tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac400357e37d27a4834b2b1d9211009ed"></a><!-- doxytag: member="bdm::MPF::drv" ref="ac400357e37d27a4834b2b1d9211009ed" args="" -->
 <a class="el" href="classbdm_1_1RV.html">RV</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1BM.html#ac400357e37d27a4834b2b1d9211009ed">drv</a></td></tr>
@@ -190,13 +154,4 @@
 bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1BM.html#afaff0ad12556fe7dc0e2807d4fd938ee">evalll</a></td></tr>
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">If true, the filter will compute likelihood of the data record and store it in <code>ll</code> . Set to false if you want to save computational time. <br/></td></tr>
-<tr><td colspan="2"><div class="groupHeader">Options</div></td></tr>
-<tr><td colspan="2"><div class="groupText"><p><a class="anchor" id="amgrpdae8ace18bdcbcc6ae5aece263e14fe8"></a> </p>
-<br/><br/></div></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a98ef9ff80c394fafd28680b7a3f831b1"></a><!-- doxytag: member="bdm::MPF::opt_L_smp" ref="a98ef9ff80c394fafd28680b7a3f831b1" args="" -->
-bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1PF.html#a98ef9ff80c394fafd28680b7a3f831b1">opt_L_smp</a></td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Log all samples. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5a49463a88ee80771a464861df845ff6"></a><!-- doxytag: member="bdm::MPF::opt_L_wei" ref="a5a49463a88ee80771a464861df845ff6" args="" -->
-bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1PF.html#a5a49463a88ee80771a464861df845ff6">opt_L_wei</a></td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Log all samples. <br/></td></tr>
 <tr><td colspan="2"><h2>Extension to conditional BM</h2></td></tr>
 <tr><td colspan="2"><p><a class="anchor" id="amgrp74e1db869c28ea37aac65bd658ff5da4"></a> This extension is useful e.g. in Marginalized Particle Filter (<a class="el" href="classbdm_1_1MPF.html">bdm::MPF</a>). Alternatively, it can be used for automated connection to <a class="el" href="classbdm_1_1DS.html" title="Abstract class for discrete-time sources of data.">DS</a> when the condition is observed </p>
@@ -244,21 +199,19 @@
 <div class="fragment"><pre class="fragment"> BM* <a class="code" href="classbdm_1_1BM.html#a40f01563651c1e4fe926189e41a6b8ab">_copy_</a>()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <span class="keyword">new</span> BM(*<span class="keyword">this</span>);} 
 </pre></div> 
-<p>Reimplemented in <a class="el" href="classbdm_1_1ARX.html#aca0b54c0997cfd567f49377af5def106">bdm::ARX</a>, <a class="el" href="classbdm_1_1KalmanCh.html#a24ce65bdaa538d4d5153d709a929b996">bdm::KalmanCh</a>, <a class="el" href="classbdm_1_1EKFCh.html#a1d1d91400e3f177de9fe7962ea17adc4">bdm::EKFCh</a>, and <a class="el" href="classbdm_1_1BMEF.html#a62d2e4691bed41a1efa6b9c2e35e5c67">bdm::BMEF</a>.</p>
-
-</div>
-</div>
-<a class="anchor" id="a286d040770d08bd7ff416cea617b1b14"></a><!-- doxytag: member="bdm::MPF::bayes" ref="a286d040770d08bd7ff416cea617b1b14" args="(const vec &amp;dt)" -->
-<div class="memitem">
-<div class="memproto">
-<div class="memtemplate">
-template&lt;class BM_T &gt; </div>
-      <table class="memname">
-        <tr>
-          <td class="memname">void <a class="el" href="classbdm_1_1MPF.html">bdm::MPF</a>&lt; BM_T &gt;::bayes </td>
+<p>Reimplemented in <a class="el" href="classbdm_1_1ARX.html#aca0b54c0997cfd567f49377af5def106">bdm::ARX</a>, <a class="el" href="classbdm_1_1ARXfrg.html#a420f3f195d231723f2f2329ec900de60">bdm::ARXfrg</a>, <a class="el" href="classbdm_1_1KalmanCh.html#a24ce65bdaa538d4d5153d709a929b996">bdm::KalmanCh</a>, <a class="el" href="classbdm_1_1EKFCh.html#a1d1d91400e3f177de9fe7962ea17adc4">bdm::EKFCh</a>, and <a class="el" href="classbdm_1_1BMEF.html#a62d2e4691bed41a1efa6b9c2e35e5c67">bdm::BMEF</a>.</p>
+
+</div>
+</div>
+<a class="anchor" id="a0fbe47b20c491f25030ef2875c148892"></a><!-- doxytag: member="bdm::MPF::bayes" ref="a0fbe47b20c491f25030ef2875c148892" args="(const vec &amp;dt)" -->
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void bdm::MPF::bayes </td>
           <td>(</td>
           <td class="paramtype">const vec &amp;&nbsp;</td>
           <td class="paramname"> <em>dt</em></td>
           <td>&nbsp;)&nbsp;</td>
-          <td><code> [inline, virtual]</code></td>
+          <td><code> [virtual]</code></td>
         </tr>
       </table>
@@ -274,7 +227,37 @@
 </dl>
 
-<p>Reimplemented from <a class="el" href="classbdm_1_1PF.html#a638946eea22d4964bf9350286bb4efd8">bdm::PF</a>.</p>
-
-<p>References <a class="el" href="particles_8h_source.html#l00036">bdm::PF::_samples</a>, <a class="el" href="particles_8h_source.html#l00034">bdm::PF::_w</a>, <a class="el" href="particles_8h_source.html#l00032">bdm::PF::est</a>, <a class="el" href="bdmbase_8h_source.html#l00498">bdm::mpdf::evallogcond()</a>, <a class="el" href="particles_8h_source.html#l00038">bdm::PF::par</a>, <a class="el" href="exp__family_8cpp_source.html#l00262">bdm::eEmp::resample()</a>, <a class="el" href="particles_8h_source.html#l00043">bdm::PF::resmethod</a>, and <a class="el" href="bdmbase_8h_source.html#l00489">bdm::mpdf::samplecond()</a>.</p>
+<p>Implements <a class="el" href="classbdm_1_1BM.html#a60b1779a577367c369a932cabd3a6188">bdm::BM</a>.</p>
+
+<p>References <a class="el" href="bdmbase_8h_source.html#l01131">bdm::BM::condition()</a>.</p>
+
+</div>
+</div>
+<a class="anchor" id="a9f74326b9ca3c888cb8eff1355ba3670"></a><!-- doxytag: member="bdm::MPF::from_setting" ref="a9f74326b9ca3c888cb8eff1355ba3670" args="(const Setting &amp;set)" -->
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void bdm::MPF::from_setting </td>
+          <td>(</td>
+          <td class="paramtype">const Setting &amp;&nbsp;</td>
+          <td class="paramname"> <em>set</em></td>
+          <td>&nbsp;)&nbsp;</td>
+          <td><code> [inline, virtual]</code></td>
+        </tr>
+      </table>
+</div>
+<div class="memdoc">
+<p>configuration structure for basic <a class="el" href="classbdm_1_1PF.html" title="Trivial particle filter with proposal density equal to parameter evolution model...">PF</a> </p>
+<div class="fragment"><pre class="fragment">        BM              = BM_class;           <span class="comment">// Bayesian filtr for analytical part of the model</span>
+        parameter_pdf   = mpdf_class;         <span class="comment">// transitional pdf for non-parametric part of the model</span>
+        prior           = epdf_class;         <span class="comment">// prior probability density</span>
+        --- optional ---
+        n               = 10;                 <span class="comment">// number of particles</span>
+        resmethod       = <span class="stringliteral">&apos;systematic&apos;</span>, or <span class="stringliteral">&apos;multinomial&apos;</span>, or <span class="stringliteral">&apos;stratified&apos;</span>
+                                                                                  <span class="comment">// resampling method</span>
+</pre></div> 
+<p>Reimplemented from <a class="el" href="classbdm_1_1BM.html#a23c6a8f71f922023ab08dcb0487a86de">bdm::BM</a>.</p>
+
+<p>References <a class="el" href="user__info_8h_source.html#l00451">bdm::UI::get()</a>, <a class="el" href="particles_8h_source.html#l00323">set_options()</a>, and <a class="el" href="particles_8h_source.html#l00367">validate()</a>.</p>
 
 </div>
@@ -305,9 +288,36 @@
 </div>
 </div>
-<hr/>The documentation for this class was generated from the following file:<ul>
+<a class="anchor" id="aada1bdb117bc78035fbb49765fa7ef10"></a><!-- doxytag: member="bdm::MPF::set_options" ref="aada1bdb117bc78035fbb49765fa7ef10" args="(const string &amp;opt)" -->
+<div class="memitem">
+<div class="memproto">
+      <table class="memname">
+        <tr>
+          <td class="memname">void bdm::MPF::set_options </td>
+          <td>(</td>
+          <td class="paramtype">const string &amp;&nbsp;</td>
+          <td class="paramname"> <em>opt</em></td>
+          <td>&nbsp;)&nbsp;</td>
+          <td><code> [inline, virtual]</code></td>
+        </tr>
+      </table>
+</div>
+<div class="memdoc">
+<p>Extends options understood by <a class="el" href="classbdm_1_1BM.html#aadb539fa2585c8a2a91c54e5aebf330e" title="Set boolean options from a string, recognized are: &quot;logbounds,logll&quot;.">BM::set_options</a> by option </p>
+<ul>
+<li>logmeans - meaning </li>
+</ul>
+
+<p>Reimplemented from <a class="el" href="classbdm_1_1BM.html#aadb539fa2585c8a2a91c54e5aebf330e">bdm::BM</a>.</p>
+
+<p>Referenced by <a class="el" href="particles_8h_source.html#l00344">from_setting()</a>.</p>
+
+</div>
+</div>
+<hr/>The documentation for this class was generated from the following files:<ul>
 <li><a class="el" href="particles_8h_source.html">particles.h</a></li>
+<li>particles.cpp</li>
 </ul>
 </div>
-<hr size="1"/><address style="text-align: right;"><small>Generated on Fri Sep 18 00:12:04 2009 for mixpp by&nbsp;
+<hr size="1"/><address style="text-align: right;"><small>Generated on Sun Sep 27 00:49:06 2009 for mixpp by&nbsp;
 <a href="http://www.doxygen.org/index.html">
 <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>