Index: library/doc/html/classbdm_1_1diffbifn.html
===================================================================
--- library/doc/html/classbdm_1_1diffbifn.html (revision 641)
+++ library/doc/html/classbdm_1_1diffbifn.html (revision 651)
@@ -1,12 +1,9 @@
-<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml">
-<head>
-<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
+<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
+<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
 <title>mixpp: bdm::diffbifn Class Reference</title>
-<link href="tabs.css" rel="stylesheet" type="text/css"/>
-<link href="doxygen.css" rel="stylesheet" type="text/css"/>
-</head>
-<body>
-<!-- Generated by Doxygen 1.6.1 -->
+<link href="tabs.css" rel="stylesheet" type="text/css">
+<link href="doxygen.css" rel="stylesheet" type="text/css">
+</head><body>
+<!-- Generated by Doxygen 1.5.9 -->
 <script type="text/javascript">
 <!--
@@ -71,78 +68,97 @@
 </div>
 <div class="contents">
-<h1>bdm::diffbifn Class Reference</h1><!-- doxytag: class="bdm::diffbifn" --><!-- doxytag: inherits="bdm::fnc" -->
-<p>Class representing a differentiable function of two variables <img class="formulaInl" alt="$f(x,u)$" src="form_50.png"/>.  
-<a href="#_details">More...</a></p>
-<hr/><a name="_details"></a><h2>Detailed Description</h2>
-<p>Class representing a differentiable function of two variables <img class="formulaInl" alt="$f(x,u)$" src="form_50.png"/>. </p>
-<p>Function of two variables.</p>
-<p>TODO: 1) Technically, it could have a common parent (e.g. <code><a class="el" href="classbdm_1_1fnc.html" title="Class representing function  of variable  represented by rv.">fnc</a></code> ) with other functions. For now, we keep it as it is. 2) It could be generalized into multivariate form, (which was original meaning of <code><a class="el" href="classbdm_1_1fnc.html" title="Class representing function  of variable  represented by rv.">fnc</a></code> ). </p>
-
-<p><code>#include &lt;<a class="el" href="functions_8h_source.html">functions.h</a>&gt;</code></p>
-
-<p><a href="classbdm_1_1diffbifn-members.html">List of all members.</a></p>
-<table border="0" cellpadding="0" cellspacing="0">
-<tr><td colspan="2"><h2>Public Member Functions</h2></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a188f31066bd72e1bf0ddacd1eb0e6af3"></a><!-- doxytag: member="bdm::diffbifn::eval" ref="a188f31066bd72e1bf0ddacd1eb0e6af3" args="(const vec &amp;cond)" -->
-vec&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#a188f31066bd72e1bf0ddacd1eb0e6af3">eval</a> (const vec &amp;cond)</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Evaluates <img class="formulaInl" alt="$f(x0,u0)$" src="form_52.png"/> (VS: Do we really need common eval? ). <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab5462c05b58cd38367ff946836bb82d3"></a><!-- doxytag: member="bdm::diffbifn::eval" ref="ab5462c05b58cd38367ff946836bb82d3" args="(const vec &amp;x0, const vec &amp;u0)" -->
-virtual vec&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#ab5462c05b58cd38367ff946836bb82d3">eval</a> (const vec &amp;x0, const vec &amp;u0)</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Evaluates <img class="formulaInl" alt="$f(x0,u0)$" src="form_52.png"/>. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#a651184f808a35f236dbfea21aca1b6ac">dfdx_cond</a> (const vec &amp;x0, const vec &amp;u0, mat &amp;A, bool full=true)</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Evaluates <img class="formulaInl" alt="$A=\frac{d}{dx}f(x,u)|_{x0,u0}$" src="form_53.png"/> and writes result into <code>A</code> .  <a href="#a651184f808a35f236dbfea21aca1b6ac"></a><br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#a6ea1dc7a482601b29c5ba36a52d20d07">dfdu_cond</a> (const vec &amp;x0, const vec &amp;u0, mat &amp;A, bool full=true)</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Evaluates <img class="formulaInl" alt="$A=\frac{d}{du}f(x,u)|_{x0,u0}$" src="form_55.png"/> and writes result into <code>A</code> .  <a href="#a6ea1dc7a482601b29c5ba36a52d20d07"></a><br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a92ff29d748e445b440453a38d0b09681"></a><!-- doxytag: member="bdm::diffbifn::diffbifn" ref="a92ff29d748e445b440453a38d0b09681" args="()" -->
-&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#a92ff29d748e445b440453a38d0b09681">diffbifn</a> ()</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Default constructor (dimy is not set!). <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1b3c8f5949f13d86d2661e191d4b369b"></a><!-- doxytag: member="bdm::diffbifn::_dimx" ref="a1b3c8f5949f13d86d2661e191d4b369b" args="() const " -->
-int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#a1b3c8f5949f13d86d2661e191d4b369b">_dimx</a> () const </td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">access function <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a031458f38c97cdb3aecde16f6a06dced"></a><!-- doxytag: member="bdm::diffbifn::_dimu" ref="a031458f38c97cdb3aecde16f6a06dced" args="() const " -->
-int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#a031458f38c97cdb3aecde16f6a06dced">_dimu</a> () const </td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">access function <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0786e40fade2663a70d654c1dda5d73e"></a><!-- doxytag: member="bdm::diffbifn::condition" ref="a0786e40fade2663a70d654c1dda5d73e" args="(const vec &amp;val)" -->
-virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1fnc.html#a0786e40fade2663a70d654c1dda5d73e">condition</a> (const vec &amp;val)</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">function substitutes given value into an appropriate position <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a083832294da9d1e40804158b979c4341"></a><!-- doxytag: member="bdm::diffbifn::dimension" ref="a083832294da9d1e40804158b979c4341" args="() const " -->
-int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1fnc.html#a083832294da9d1e40804158b979c4341">dimension</a> () const </td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">access function <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aaf0e6941ba5919cae1bc530e2181b109"></a><!-- doxytag: member="bdm::diffbifn::to_string" ref="aaf0e6941ba5919cae1bc530e2181b109" args="()" -->
-virtual string&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#aaf0e6941ba5919cae1bc530e2181b109">to_string</a> ()</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method returns a basic info about the current instance. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0551e3121091c5199bf4413b50522176"></a><!-- doxytag: member="bdm::diffbifn::from_setting" ref="a0551e3121091c5199bf4413b50522176" args="(const Setting &amp;set)" -->
-virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#a0551e3121091c5199bf4413b50522176">from_setting</a> (const Setting &amp;set)</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method arrange instance properties according the data stored in the Setting structure. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a67d954d255ede776eade7334d4895790"></a><!-- doxytag: member="bdm::diffbifn::to_setting" ref="a67d954d255ede776eade7334d4895790" args="(Setting &amp;set) const " -->
-virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#a67d954d255ede776eade7334d4895790">to_setting</a> (Setting &amp;set) const </td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method save all the instance properties into the Setting structure. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1c314bd6d6dacb8ba78ea5eb88fd9516"></a><!-- doxytag: member="bdm::diffbifn::validate" ref="a1c314bd6d6dacb8ba78ea5eb88fd9516" args="()" -->
-virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#a1c314bd6d6dacb8ba78ea5eb88fd9516">validate</a> ()</td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method TODO. <br/></td></tr>
-<tr><td colspan="2"><h2>Protected Attributes</h2></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5f56547d8e9378b669d3cc19d7831cbb"></a><!-- doxytag: member="bdm::diffbifn::rvx" ref="a5f56547d8e9378b669d3cc19d7831cbb" args="" -->
-<a class="el" href="classbdm_1_1RV.html">RV</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#a5f56547d8e9378b669d3cc19d7831cbb">rvx</a></td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Indentifier of the first rv. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa8e3e861d5ec2a7ae9524e6338e58320"></a><!-- doxytag: member="bdm::diffbifn::rvu" ref="aa8e3e861d5ec2a7ae9524e6338e58320" args="" -->
-<a class="el" href="classbdm_1_1RV.html">RV</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#aa8e3e861d5ec2a7ae9524e6338e58320">rvu</a></td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Indentifier of the second rv. <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa193aa2c4a500139c0c4b669691e588e"></a><!-- doxytag: member="bdm::diffbifn::dimx" ref="aa193aa2c4a500139c0c4b669691e588e" args="" -->
-int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#aa193aa2c4a500139c0c4b669691e588e">dimx</a></td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">cache for rvx.count() <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a30c45617eec89adeb4ebaa763d093fb0"></a><!-- doxytag: member="bdm::diffbifn::dimu" ref="a30c45617eec89adeb4ebaa763d093fb0" args="" -->
-int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#a30c45617eec89adeb4ebaa763d093fb0">dimu</a></td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">cache for rvu.count() <br/></td></tr>
-<tr><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a52156cb4a52a62d51fc7455985797a62"></a><!-- doxytag: member="bdm::diffbifn::dimy" ref="a52156cb4a52a62d51fc7455985797a62" args="" -->
-int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1fnc.html#a52156cb4a52a62d51fc7455985797a62">dimy</a></td></tr>
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Length of the output vector. <br/></td></tr>
+<h1>bdm::diffbifn Class Reference</h1><!-- doxytag: class="bdm::diffbifn" --><!-- doxytag: inherits="bdm::fnc" -->Class representing a differentiable function of two variables <img class="formulaInl" alt="$f(x,u)$" src="form_50.png">.  
+<a href="#_details">More...</a>
+<p>
+<code>#include &lt;<a class="el" href="functions_8h_source.html">functions.h</a>&gt;</code>
+<p>
+
+<p>
+<a href="classbdm_1_1diffbifn-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
+<tr><td></td></tr>
+<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="188f31066bd72e1bf0ddacd1eb0e6af3"></a><!-- doxytag: member="bdm::diffbifn::eval" ref="188f31066bd72e1bf0ddacd1eb0e6af3" args="(const vec &amp;cond)" -->
+vec&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#188f31066bd72e1bf0ddacd1eb0e6af3">eval</a> (const vec &amp;cond)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Evaluates <img class="formulaInl" alt="$f(x0,u0)$" src="form_52.png"> (VS: Do we really need common eval? ). <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="b5462c05b58cd38367ff946836bb82d3"></a><!-- doxytag: member="bdm::diffbifn::eval" ref="b5462c05b58cd38367ff946836bb82d3" args="(const vec &amp;x0, const vec &amp;u0)" -->
+virtual vec&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#b5462c05b58cd38367ff946836bb82d3">eval</a> (const vec &amp;x0, const vec &amp;u0)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Evaluates <img class="formulaInl" alt="$f(x0,u0)$" src="form_52.png">. <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#651184f808a35f236dbfea21aca1b6ac">dfdx_cond</a> (const vec &amp;x0, const vec &amp;u0, mat &amp;A, bool full=true)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Evaluates <img class="formulaInl" alt="$A=\frac{d}{dx}f(x,u)|_{x0,u0}$" src="form_53.png"> and writes result into <code>A</code> .  <a href="#651184f808a35f236dbfea21aca1b6ac"></a><br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#6ea1dc7a482601b29c5ba36a52d20d07">dfdu_cond</a> (const vec &amp;x0, const vec &amp;u0, mat &amp;A, bool full=true)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Evaluates <img class="formulaInl" alt="$A=\frac{d}{du}f(x,u)|_{x0,u0}$" src="form_55.png"> and writes result into <code>A</code> .  <a href="#6ea1dc7a482601b29c5ba36a52d20d07"></a><br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="92ff29d748e445b440453a38d0b09681"></a><!-- doxytag: member="bdm::diffbifn::diffbifn" ref="92ff29d748e445b440453a38d0b09681" args="()" -->
+&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#92ff29d748e445b440453a38d0b09681">diffbifn</a> ()</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Default constructor (dimy is not set!). <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="1b3c8f5949f13d86d2661e191d4b369b"></a><!-- doxytag: member="bdm::diffbifn::_dimx" ref="1b3c8f5949f13d86d2661e191d4b369b" args="() const " -->
+int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#1b3c8f5949f13d86d2661e191d4b369b">_dimx</a> () const </td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">access function <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="031458f38c97cdb3aecde16f6a06dced"></a><!-- doxytag: member="bdm::diffbifn::_dimu" ref="031458f38c97cdb3aecde16f6a06dced" args="() const " -->
+int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#031458f38c97cdb3aecde16f6a06dced">_dimu</a> () const </td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">access function <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="0786e40fade2663a70d654c1dda5d73e"></a><!-- doxytag: member="bdm::diffbifn::condition" ref="0786e40fade2663a70d654c1dda5d73e" args="(const vec &amp;val)" -->
+virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1fnc.html#0786e40fade2663a70d654c1dda5d73e">condition</a> (const vec &amp;val)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">function substitutes given value into an appropriate position <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="083832294da9d1e40804158b979c4341"></a><!-- doxytag: member="bdm::diffbifn::dimension" ref="083832294da9d1e40804158b979c4341" args="() const " -->
+int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1fnc.html#083832294da9d1e40804158b979c4341">dimension</a> () const </td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">access function <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="af0e6941ba5919cae1bc530e2181b109"></a><!-- doxytag: member="bdm::diffbifn::to_string" ref="af0e6941ba5919cae1bc530e2181b109" args="()" -->
+virtual string&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#af0e6941ba5919cae1bc530e2181b109">to_string</a> ()</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method returns a basic info about the current instance. <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="0551e3121091c5199bf4413b50522176"></a><!-- doxytag: member="bdm::diffbifn::from_setting" ref="0551e3121091c5199bf4413b50522176" args="(const Setting &amp;set)" -->
+virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#0551e3121091c5199bf4413b50522176">from_setting</a> (const Setting &amp;set)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method arrange instance properties according the data stored in the Setting structure. <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="67d954d255ede776eade7334d4895790"></a><!-- doxytag: member="bdm::diffbifn::to_setting" ref="67d954d255ede776eade7334d4895790" args="(Setting &amp;set) const " -->
+virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#67d954d255ede776eade7334d4895790">to_setting</a> (Setting &amp;set) const </td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method save all the instance properties into the Setting structure. <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="1c314bd6d6dacb8ba78ea5eb88fd9516"></a><!-- doxytag: member="bdm::diffbifn::validate" ref="1c314bd6d6dacb8ba78ea5eb88fd9516" args="()" -->
+virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1root.html#1c314bd6d6dacb8ba78ea5eb88fd9516">validate</a> ()</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method TODO. <br></td></tr>
+<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="5f56547d8e9378b669d3cc19d7831cbb"></a><!-- doxytag: member="bdm::diffbifn::rvx" ref="5f56547d8e9378b669d3cc19d7831cbb" args="" -->
+<a class="el" href="classbdm_1_1RV.html">RV</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#5f56547d8e9378b669d3cc19d7831cbb">rvx</a></td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Indentifier of the first rv. <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="a8e3e861d5ec2a7ae9524e6338e58320"></a><!-- doxytag: member="bdm::diffbifn::rvu" ref="a8e3e861d5ec2a7ae9524e6338e58320" args="" -->
+<a class="el" href="classbdm_1_1RV.html">RV</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#a8e3e861d5ec2a7ae9524e6338e58320">rvu</a></td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Indentifier of the second rv. <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="a193aa2c4a500139c0c4b669691e588e"></a><!-- doxytag: member="bdm::diffbifn::dimx" ref="a193aa2c4a500139c0c4b669691e588e" args="" -->
+int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#a193aa2c4a500139c0c4b669691e588e">dimx</a></td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">cache for rvx.count() <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="30c45617eec89adeb4ebaa763d093fb0"></a><!-- doxytag: member="bdm::diffbifn::dimu" ref="30c45617eec89adeb4ebaa763d093fb0" args="" -->
+int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1diffbifn.html#30c45617eec89adeb4ebaa763d093fb0">dimu</a></td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">cache for rvu.count() <br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="52156cb4a52a62d51fc7455985797a62"></a><!-- doxytag: member="bdm::diffbifn::dimy" ref="52156cb4a52a62d51fc7455985797a62" args="" -->
+int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1fnc.html#52156cb4a52a62d51fc7455985797a62">dimy</a></td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Length of the output vector. <br></td></tr>
 </table>
-<hr/><h2>Member Function Documentation</h2>
-<a class="anchor" id="a6ea1dc7a482601b29c5ba36a52d20d07"></a><!-- doxytag: member="bdm::diffbifn::dfdu_cond" ref="a6ea1dc7a482601b29c5ba36a52d20d07" args="(const vec &amp;x0, const vec &amp;u0, mat &amp;A, bool full=true)" -->
+<hr><a name="_details"></a><h2>Detailed Description</h2>
+Class representing a differentiable function of two variables <img class="formulaInl" alt="$f(x,u)$" src="form_50.png">. 
+<p>
+Function of two variables.<p>
+TODO: 1) Technically, it could have a common parent (e.g. <code><a class="el" href="classbdm_1_1fnc.html" title="Class representing function  of variable  represented by rv.">fnc</a></code> ) with other functions. For now, we keep it as it is. 2) It could be generalized into multivariate form, (which was original meaning of <code><a class="el" href="classbdm_1_1fnc.html" title="Class representing function  of variable  represented by rv.">fnc</a></code> ). <hr><h2>Member Function Documentation</h2>
+<a class="anchor" name="6ea1dc7a482601b29c5ba36a52d20d07"></a><!-- doxytag: member="bdm::diffbifn::dfdu_cond" ref="6ea1dc7a482601b29c5ba36a52d20d07" args="(const vec &amp;x0, const vec &amp;u0, mat &amp;A, bool full=true)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">virtual void bdm::diffbifn::dfdu_cond </td>
+          <td class="memname">virtual void bdm::diffbifn::dfdu_cond           </td>
           <td>(</td>
           <td class="paramtype">const vec &amp;&nbsp;</td>
@@ -176,25 +192,26 @@
 <div class="memdoc">
 
-<p>Evaluates <img class="formulaInl" alt="$A=\frac{d}{du}f(x,u)|_{x0,u0}$" src="form_55.png"/> and writes result into <code>A</code> . </p>
-<dl><dt><b>Parameters:</b></dt><dd>
+<p>
+Evaluates <img class="formulaInl" alt="$A=\frac{d}{du}f(x,u)|_{x0,u0}$" src="form_55.png"> and writes result into <code>A</code> . 
+<p>
+<dl compact><dt><b>Parameters:</b></dt><dd>
   <table border="0" cellspacing="2" cellpadding="0">
     <tr><td valign="top"></td><td valign="top"><em>full</em>&nbsp;</td><td>denotes that even unchanged entries are to be rewritten. When, false only the changed elements are computed. </td></tr>
-    <tr><td valign="top"></td><td valign="top"><em>x0</em>&nbsp;</td><td>numeric value of <img class="formulaInl" alt="$x$" src="form_1.png"/>, </td></tr>
-    <tr><td valign="top"></td><td valign="top"><em>u0</em>&nbsp;</td><td>numeric value of <img class="formulaInl" alt="$u$" src="form_54.png"/> </td></tr>
+    <tr><td valign="top"></td><td valign="top"><em>x0</em>&nbsp;</td><td>numeric value of <img class="formulaInl" alt="$x$" src="form_1.png">, </td></tr>
+    <tr><td valign="top"></td><td valign="top"><em>u0</em>&nbsp;</td><td>numeric value of <img class="formulaInl" alt="$u$" src="form_54.png"> </td></tr>
     <tr><td valign="top"></td><td valign="top"><em>A</em>&nbsp;</td><td>a place where the result will be stored. </td></tr>
   </table>
-  </dd>
 </dl>
 
-<p>Reimplemented in <a class="el" href="classbdm_1_1bilinfn.html#a9cfe2f1c115ba7c3c75849a10a4f2c08">bdm::bilinfn</a>.</p>
-
-</div>
-</div>
-<a class="anchor" id="a651184f808a35f236dbfea21aca1b6ac"></a><!-- doxytag: member="bdm::diffbifn::dfdx_cond" ref="a651184f808a35f236dbfea21aca1b6ac" args="(const vec &amp;x0, const vec &amp;u0, mat &amp;A, bool full=true)" -->
+<p>Reimplemented in <a class="el" href="classbdm_1_1bilinfn.html#9cfe2f1c115ba7c3c75849a10a4f2c08">bdm::bilinfn</a>.</p>
+
+</div>
+</div><p>
+<a class="anchor" name="651184f808a35f236dbfea21aca1b6ac"></a><!-- doxytag: member="bdm::diffbifn::dfdx_cond" ref="651184f808a35f236dbfea21aca1b6ac" args="(const vec &amp;x0, const vec &amp;u0, mat &amp;A, bool full=true)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">virtual void bdm::diffbifn::dfdx_cond </td>
+          <td class="memname">virtual void bdm::diffbifn::dfdx_cond           </td>
           <td>(</td>
           <td class="paramtype">const vec &amp;&nbsp;</td>
@@ -228,26 +245,26 @@
 <div class="memdoc">
 
-<p>Evaluates <img class="formulaInl" alt="$A=\frac{d}{dx}f(x,u)|_{x0,u0}$" src="form_53.png"/> and writes result into <code>A</code> . </p>
-<dl><dt><b>Parameters:</b></dt><dd>
+<p>
+Evaluates <img class="formulaInl" alt="$A=\frac{d}{dx}f(x,u)|_{x0,u0}$" src="form_53.png"> and writes result into <code>A</code> . 
+<p>
+<dl compact><dt><b>Parameters:</b></dt><dd>
   <table border="0" cellspacing="2" cellpadding="0">
     <tr><td valign="top"></td><td valign="top"><em>full</em>&nbsp;</td><td>denotes that even unchanged entries are to be rewritten. When, false only the changed elements are computed. </td></tr>
-    <tr><td valign="top"></td><td valign="top"><em>x0</em>&nbsp;</td><td>numeric value of <img class="formulaInl" alt="$x$" src="form_1.png"/>, </td></tr>
-    <tr><td valign="top"></td><td valign="top"><em>u0</em>&nbsp;</td><td>numeric value of <img class="formulaInl" alt="$u$" src="form_54.png"/> </td></tr>
+    <tr><td valign="top"></td><td valign="top"><em>x0</em>&nbsp;</td><td>numeric value of <img class="formulaInl" alt="$x$" src="form_1.png">, </td></tr>
+    <tr><td valign="top"></td><td valign="top"><em>u0</em>&nbsp;</td><td>numeric value of <img class="formulaInl" alt="$u$" src="form_54.png"> </td></tr>
     <tr><td valign="top"></td><td valign="top"><em>A</em>&nbsp;</td><td>a place where the result will be stored. </td></tr>
   </table>
-  </dd>
 </dl>
 
-<p>Reimplemented in <a class="el" href="classbdm_1_1bilinfn.html#a33066f1054dd259df2ec5fafae4b46e6">bdm::bilinfn</a>.</p>
-
-</div>
-</div>
-<hr/>The documentation for this class was generated from the following file:<ul>
-<li><a class="el" href="functions_8h_source.html">functions.h</a></li>
-</ul>
-</div>
-<hr size="1"/><address style="text-align: right;"><small>Generated on Sun Sep 27 00:49:06 2009 for mixpp by&nbsp;
+<p>Reimplemented in <a class="el" href="classbdm_1_1bilinfn.html#33066f1054dd259df2ec5fafae4b46e6">bdm::bilinfn</a>.</p>
+
+</div>
+</div><p>
+<hr>The documentation for this class was generated from the following file:<ul>
+<li><a class="el" href="functions_8h_source.html">functions.h</a></ul>
+</div>
+<hr size="1"><address style="text-align: right;"><small>Generated on Wed Oct 7 17:34:47 2009 for mixpp by&nbsp;
 <a href="http://www.doxygen.org/index.html">
-<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
+<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.9 </small></address>
 </body>
 </html>