Index: library/bdm/base/user_info.h
===================================================================
--- library/bdm/base/user_info.h (revision 635)
+++ library/bdm/base/user_info.h (revision 659)
@@ -3,5 +3,5 @@
   \brief UI (user info) class for loading/saving objects from/to configuration files.
   It is designed with use of libconfig C/C++ Configuration File Library
-  \ref ui_page
+  \ref ui
   \author Vaclav Smidl.
 
@@ -36,5 +36,5 @@
 //! Generic exception for reporting configuration errors
 //!
-//!  \ref ui_page
+//!  \ref ui
 class UIException : public std::exception {
 private:
@@ -68,5 +68,5 @@
 //! Exception for reporting configuration errors related to some concrete Setting path
 //!
-//!  \ref ui_page
+//!  \ref ui
 class UISettingException : public UIException {
 public:
@@ -86,5 +86,5 @@
 //! Exception for reporting configuration errors in the "class" attribute
 //!
-//!  \ref ui_page
+//!  \ref ui
 class UIClassException : public UIException {
 public:
@@ -124,5 +124,5 @@
 \endcode
 
-\ref ui_page
+\ref ui
 */
 class UIFile : public Config {
@@ -205,5 +205,5 @@
 that the #result Setting reference is valid within the scope of SettingResolver instance.
 
-\ref ui_page
+\ref ui
  */
 class SettingResolver : root {
@@ -238,5 +238,5 @@
 descendant ParticularUI<T>.
 
-\ref ui_page
+\ref ui
 */
 class UI {
@@ -579,5 +579,5 @@
 
 //! The only UI descendant class which is not intended for direct use. It should be accessed within the UIREGISTER macro only.
-//! \ref ui_page
+//! \ref ui
 template<typename T> class ParticularUI : private UI {
 public:
@@ -600,5 +600,5 @@
   This macro should be used in header file, immediately after a class declaration.
 
-  \ref ui_page
+  \ref ui
 */
 #ifndef BDMLIB
@@ -617,5 +617,5 @@
   Technical meann of registering UIREGISTER(class_name<template_name>).
 
-  \ref ui_page
+  \ref ui
  */
 #ifndef BDMLIB
Index: library/doc/tutorial/arx_ui.dox
===================================================================
--- library/doc/tutorial/arx_ui.dox (revision 651)
+++ library/doc/tutorial/arx_ui.dox (revision 659)
@@ -6,5 +6,5 @@
 \section cmd Command Line
 
-In order to use it for estimation of an ARX model, we can define the following \ref ui_page "user info" structure:
+In order to use it for estimation of an ARX model, we can define the following \ref ui "user info" structure:
 \include arx_test.cfg
 
Index: library/doc/tutorial/01userguide.dox
===================================================================
--- library/doc/tutorial/01userguide.dox (revision 652)
+++ library/doc/tutorial/01userguide.dox (revision 659)
@@ -1,6 +1,6 @@
 /*!
-\page user_guide BDM Use - System, Data, Simulation
-
-This section serves as introdustion to the scenario of data simulation. Since it is the simpliest of all scenarios defined in \ref 005userguide0 it also serves as introduction to configuration of an experiment (see \ref ui_page) and basic decision making objects (bdm::RV and bdm::DS).
+\page userguide BDM Use - System, Data, Simulation
+
+This section serves as introdustion to the scenario of data simulation. Since it is the simpliest of all scenarios defined in \ref 005userguide0 it also serves as introduction to configuration of an experiment (see \ref ui) and basic decision making objects (bdm::RV and bdm::DS).
 
 All experiments are demonstarted on scenario simulator which can be either standalone application or mex file (simulator.mex**).
@@ -14,8 +14,8 @@
 
 The configuration has two possible options:
- - configuration file using syntax of libconfig (see \ref ui_page),
+ - configuration file using syntax of libconfig (see \ref ui),
  - matlab structure.
 For the purpose of tutorial, we will use the matlab notation. 
-These two options can be mutually converted from one to another using prepared mex files: config2mxstruct.mex and mxstruct2config.mex. Naturally, these scripts require matlab to run. If it is not available, manual conversion is relatively trivial, the major difference is in using different types of brackets (\ref ui_page)
+These two options can be mutually converted from one to another using prepared mex files: config2mxstruct.mex and mxstruct2config.mex. Naturally, these scripts require matlab to run. If it is not available, manual conversion is relatively trivial, the major difference is in using different types of brackets (\ref ui)
 
 \subsection ug_first First experiment
Index: library/doc/tutorial/03devguide.dox
===================================================================
--- library/doc/tutorial/03devguide.dox (revision 632)
+++ library/doc/tutorial/03devguide.dox (revision 659)
@@ -1,8 +1,8 @@
 /*!
-\page dev_guide  BDM Use - in C++ 
+\page devguide  BDM Use - in C++ 
 
 \section Intro Logic of BDM
 - \subpage intro
-- \subpage ui_page
+- \subpage ui
 - \subpage mexfiles
 
Index: library/doc/tutorial/005userguide0.dox
===================================================================
--- library/doc/tutorial/005userguide0.dox (revision 657)
+++ library/doc/tutorial/005userguide0.dox (revision 659)
@@ -1,4 +1,4 @@
 /*!
-\page user_guide0 BDM Use - Introduction
+\page userguide0 BDM Use - Introduction
 
 BDM is a library of basic components for Bayesian decision making, hence its direct use is not possible. In order to use BDM the components must be pulled together in order to achieve desired functionality. We expect two kinds of users:
@@ -24,5 +24,5 @@
 \section secnario Prepared Scenarios
 
-Since some tasks are repeatedly occuring in practical applications of decision making, these tasks has been identified and prepared as standalone applications (or mex files). These taska are implemented in separate toolbox - bdmtoolbox. Binary version of the toolbox is available see \ref instalation.
+Since some tasks are repeatedly occuring in practical applications of decision making, these tasks has been identified and prepared as standalone applications (or mex files). These taska are implemented in separate toolbox - bdmtoolbox. Binary version of the toolbox is available see \ref install.
 
 The predefined scenarios are:
@@ -35,6 +35,6 @@
 A tutorial how to run the scenarios are:
 
- - \ref user_guide
- - \ref user_guide2
+ - \ref userguide
+ - \ref userguide2
 
 */
Index: library/doc/tutorial/mexfiles.dox
===================================================================
--- library/doc/tutorial/mexfiles.dox (revision 471)
+++ library/doc/tutorial/mexfiles.dox (revision 659)
@@ -5,5 +5,5 @@
 
 A range of mexfiles is predefined in directory \c library/mex.
-Many of these mexfile process ui files (see \ref ui_page) examples of these files are in directory \c library/tutorial.
+Many of these mexfile process ui files (see \ref ui) examples of these files are in directory \c library/tutorial.
 Note that in order to run these files you need to let matlab know where to find them:
 \code
Index: library/doc/tutorial/ui.dox
===================================================================
--- library/doc/tutorial/ui.dox (revision 600)
+++ library/doc/tutorial/ui.dox (revision 659)
@@ -1,4 +1,4 @@
 /*!
-\page ui_page User Infos and their use
+\page ui User Infos and their use
  
 \sa #bdm::UI
Index: library/doc/tutorial/02userguide2.dox
===================================================================
--- library/doc/tutorial/02userguide2.dox (revision 651)
+++ library/doc/tutorial/02userguide2.dox (revision 659)
@@ -1,4 +1,4 @@
 /*!
-\page user_guide2 BDM Use - Estimation and Bayes Rule
+\page userguide2 BDM Use - Estimation and Bayes Rule
 
 Baysian theory is predominantly used in system identification, or estimation problems. 
@@ -21,5 +21,5 @@
 \li Result Logger is an object (class logger) dedicated to storing important data from the experiment.
 
-Since objects  datasource and the logger has already been introduced in section \ref user_guide, it remains to introduce 
+Since objects  datasource and the logger has already been introduced in section \ref userguide, it remains to introduce 
 object \c Bayesian \c Model (bdm::BM).
 
Index: library/doc/tutorial/04devguide2.dox
===================================================================
--- library/doc/tutorial/04devguide2.dox (revision 632)
+++ library/doc/tutorial/04devguide2.dox (revision 659)
@@ -1,4 +1,4 @@
 /*!
-\page dev_guide2 BDM Development - Contribution guide
+\page devguide2 BDM Development - Contribution guide
 \addindex Howto Contribute to BDM - Advanced development
 